/*==========================================================================
 *
 *  Copyleft (C) 1996 Interactive Computer Graphics. All Rights "UN-Reserved".
 *
 *  File:       ddex.cpp
 *  Content:    Direct Draw example program.
 *				This is modified from ddex1.cpp wroten by Microsoft.
 *
 *	2001/10/5	Modified by Alex Ma
 *				1.	Add some chinese comments
 *				2.	Add a code section about how to do direct memory access
 *	2004/09/22  Modified by Kinomoto
 *				1.  Rearrange code structure
 *              2.  Add a TRI importer class
 ***************************************************************************/

#define NAME "DDExample"
#define TITLE "Direct Draw Example"

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include <ddraw.h>
#include <stdlib.h>
#include <stdarg.h>
#include "MyModel.h"

void repaint(HWND hWnd, HDC hDC);
void drawTriangle (HDC hdc, int X1, int Y1, int X2, int Y2, int X3, int Y3);

//	HUnDirectDrawαԭz󪺫ŧi
LPDIRECTDRAW            lpDD;           // DirectDraw Object
LPDIRECTDRAWSURFACE     lpDDSPrimary;   // DirectDraw Primary Surface
LPDIRECTDRAWSURFACE     lpDDSBack;      // DirectDraw Back Surface
DDSURFACEDESC			ddsd;			// DirectDraw Surface Descriptor
DDSCAPS					ddscaps;

BOOL                    bActive;        // is application active?
WORD					mColor = 0 ;

WORD					mScreenWidth	= 1024; // ùe
WORD					mScreenHeight	= 768;	// ù
WORD					mColorDepth	= 32;	// ù`

void repaint(HWND hWnd, HDC hDC)
{
	DWORD	x,y ;
    RECT        rc;
	GetClientRect(hWnd, &rc);

	//	Clear Screen
	//	IMPORTANT
	//	HUSectionФjapbDirectDraw̭sSurface Buffer

	DWORD	*vmem = (DWORD *)ddsd.lpSurface ;	// NLockLSurfacevmem
	for(y=0; y < ddsd.dwHeight; y++)			// SurfaceCy]_lȬs^
	{
		for(x=0; x < ddsd.dwWidth; x++)			// SurfaceCx]_lȬs^
			vmem[x] = mColor ;					// N쪺vmemmȶWmColor]Pn-bit)

		vmem += ddsd.lPitch/sizeof(DWORD) ;		// NvmemVSuface޿WU@C
		mColor += 2 ;							// NC⪺
	}

	// For every face
		// Transformation
		// Projection
		// Clipping
		// Transfer to screen coordinates

	// Example of drawing a triangle
	// You can use LineTo to draw wireframe
	drawTriangle(hDC, (rc.right + rc.left)/2, (rc.top + rc.bottom)/2-100,
				  (rc.right + rc.left)/2-100, (rc.top + rc.bottom)/2+100, 
				  (rc.right + rc.left)/2+100, (rc.top + rc.bottom)/2+100);
}

void drawTriangle (HDC hdc, int X1, int Y1, int X2, int Y2, int X3, int Y3)
{
	// Example Code
	MoveToEx (hdc, X1, Y1, NULL);
	LineTo (hdc, X2, Y2);
	LineTo (hdc, X3, Y3);
	LineTo (hdc, X1, Y1);
}


static void finiObjects( void )
{
    if( lpDD != NULL )
    {
        if( lpDDSPrimary != NULL )
        {
            lpDDSPrimary->Release();
            lpDDSPrimary = NULL;
        }
        lpDD->Release();
        lpDD = NULL;
    }
}


long FAR PASCAL WindowProc( HWND hWnd, UINT message, 
                            WPARAM wParam, LPARAM lParam )
{
//  PAINTSTRUCT ps;
//	HGDIOBJ		OldPen;

    switch( message )
    {
    case WM_ACTIVATEAPP:
        bActive = wParam;
        break;

    case WM_CREATE:
        break;

    case WM_SETCURSOR:
        SetCursor(NULL);
        return TRUE;
 
    case WM_KEYDOWN:
        switch( wParam )
        {
        case VK_ESCAPE:
        case VK_F12:
            PostMessage(hWnd, WM_CLOSE, 0, 0);
		default:
			if(lpDDSBack->Lock( NULL , &ddsd , DDLOCK_WAIT , NULL ) == DD_OK)
			{
				HDC hDC ;
				lpDDSBack->GetDC(&hDC) ;
				repaint(hWnd,hDC);
				lpDDSBack->ReleaseDC(hDC) ;
				lpDDSBack->Unlock(NULL) ;
			}
			
			while (TRUE)
			{
				DWORD hRet = lpDDSPrimary->Flip(NULL, 0);
				if (hRet == DD_OK)
					break;
				if (hRet == DDERR_SURFACELOST)
				{
					hRet = lpDDSPrimary->Restore();
					if (hRet != DD_OK)
						break;
				}
				if (hRet != DDERR_WASSTILLDRAWING)
					break;
			}

            break;
        }
        break;

    case WM_PAINT:
        break;

    case WM_DESTROY:
        finiObjects();
        PostQuitMessage( 0 );
        break;
    }

    return DefWindowProc(hWnd, message, wParam, lParam);
}


static BOOL doInit( HINSTANCE hInstance, int nCmdShow )
{
    HWND                hwnd;
    WNDCLASS            wc;
    HRESULT             ddrval;
    char                buf[256];

//	Set up and register window class
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WindowProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(hInstance, IDI_APPLICATION) ;
    wc.hCursor = LoadCursor(NULL, IDC_ARROW) ;
    wc.hbrBackground = NULL;
    wc.lpszMenuName = NAME;
    wc.lpszClassName = NAME;
    RegisterClass( &wc );

//	Create a window
    hwnd = CreateWindowEx(
        WS_EX_TOPMOST,
        NAME,
        TITLE,
        WS_POPUP,
        0, 0,
        GetSystemMetrics( SM_CXSCREEN ),
        GetSystemMetrics( SM_CYSCREEN ),
        NULL,
        NULL,
        hInstance,
        NULL );

    if(!hwnd)
        return FALSE;

    ShowWindow(hwnd, nCmdShow);
    UpdateWindow(hwnd);

//	IMPORTANT
//	HUSectionФjapإߤ@Double BufferedDirectDraw System

//	#1	Create the main DirectDraw object
    ddrval = DirectDrawCreate( NULL, &lpDD, NULL );
    if(ddrval == DD_OK)
    {
        //	#2	Get exclusive and full-screen mode
        ddrval = lpDD->SetCooperativeLevel( hwnd,
                                DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN );
        if(ddrval == DD_OK)
        {
			//	#3	Set display mode for Width*Height , n-bit per pixel
            ddrval = lpDD->SetDisplayMode(mScreenWidth , mScreenHeight , mColorDepth);
            if(ddrval == DD_OK)
            {
                //	#4	Create the primary surface with 1 back buffer
                ddsd.dwSize		= sizeof(ddsd);
                ddsd.dwFlags	= DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
                ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE |
                                      DDSCAPS_FLIP | 
                                      DDSCAPS_COMPLEX;
                ddsd.dwBackBufferCount = 1;
                ddrval = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );
                if(ddrval == DD_OK)
                {
                    //	#5	Get a pointer to the back buffer
                    ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
                    ddrval = lpDDSPrimary->GetAttachedSurface(&ddscaps, 
                                                          &lpDDSBack);
                    if(ddrval == DD_OK)
                    {
                         return TRUE;
                    }
                }
            }
        }
    }

    wsprintf(buf, "Direct Draw Init Failed (%08lx)\n", ddrval );
    MessageBox( hwnd, buf, "ERROR", MB_OK );
    finiObjects();
    DestroyWindow( hwnd );
    return FALSE;
}


int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                        LPSTR lpCmdLine, int nCmdShow)
{
    MSG         msg;

    lpCmdLine = lpCmdLine;
    hPrevInstance = hPrevInstance;

    if( !doInit( hInstance, nCmdShow ) )
    {
        return FALSE;
    }

    while (GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return msg.wParam;

}
